
(function () {
    TK.Initialize(TK.CheckNativeInterfaceAvailable());
    var createVideoBlock = window.createVideoBlock,
        findLiDom = window.findLiDom,
        createSwitch = window.createSwitch,
        removeAllLi = window.removeAllLi,
        createButtons = window.createButtons,
        createUserLi = window.createUserLi,
        removeUserli = window.removeUserli,
        delAdditionalDom = window.delAdditionalDom,
        changeBtnStats = window.changeBtnStats,
        additionalDom = window.additionalDom;
    window._room = TK.Room();
    window.prefixStr = 'container';
    window.volStr = 'vol';
    window.tk_multistream = false;
    window.TKevent = TK.EventDispatcher();
    var RoomEvent = {};//房间事件
    var _videoMirror = false;
    var _videoLoader = true;
    var _videoMode = TK_VIDEO_MODE.ASPECT_RATIO_COVER; // 视频显示模式
    var _isRoomOnlyAudio = false; // 房间是否只有音频
    var _isDebugLog = getParams('debug') === 'true'; //是否是debug级别日志
    var OperationState = {
        Stopped: '_STOPPED_',
        Started: '_STARTED_',
        Paused: '_PAUSED_',
    };
    var _serverRecordState = OperationState.Stopped; // 服务器录制状态
    var videolist = [];
    var mdId = '';
    var allUser = {};
    var sharePubId = '';
    var loginType = {fileName: 'SDK-DEMO:controller.js'};
    TK.DEMOconnected = false;
    _room.setLogIsDebug(_isDebugLog);
    Object.defineProperties(RoomEvent, {
        roomError: { //room-connected 房间连接成功事件
            value: TK.EVENT_TYPE.roomError,
            writable: false,
            enumerable: true,
        },
        roomConnected: { //room-connected 房间连接成功事件
            value: TK.EVENT_TYPE.roomConnected,
            writable: false,
            enumerable: true,
        },
        roomConnectFail: { //room-connect-fail 房间连接失败事件
            value: TK.EVENT_TYPE.roomConnectFail,
            writable: false,
            enumerable: true,
        },
        roomCheckroom: { //room-checkroom 房间检测事件
            value: TK.EVENT_TYPE.roomCheckroom,
            writable: false,
            enumerable: true,
        },
        roomCheckroomPlayback: { //room-checkroom-playback 回放的checkroom事件
            value: TK.EVENT_TYPE.roomCheckroomPlayback,
            writable: false,
            enumerable: true,
        },
        roomAudiovideostateSwitched: { //room-audiovideostate-switched 纯音频房间切换事件
            value: TK.EVENT_TYPE.roomAudioVideoStateSwitched,
            writable: false,
            enumerable: true,
        },
        roomModeChanged: { //room-mode-changed 房间模式切换
            value: TK.EVENT_TYPE.roomModeChanged,
            writable: false,
            enumerable: true,
        },
        roomParticipantLeave: {  //room-participant_leave  参与者离开房间事件
            value: TK.EVENT_TYPE.roomParticipantLeave,
            writable: false,
            enumerable: true,
        },
        roomParticipantEvicted: {  //room-participant_evicted 参与者被踢事件
            value: TK.EVENT_TYPE.roomParticipantEvicted,
            writable: false,
            enumerable: true,
        },
        roomTextMessage: { //	room-text-message 聊天消息事件
            value: TK.EVENT_TYPE.roomTextMessage,
            writable: false,
            enumerable: true,
        },
        roomUservideostateChanged: {  //room-uservideostate-changed 用户视频发布状态改变
            value: TK.EVENT_TYPE.roomUserVideoStateChanged,
            writable: false,
            enumerable: true,
        },
        roomUseraudiostateChanged: {  //room-useraudiostate-changed 用户音频发布状态改变
            value: TK.EVENT_TYPE.roomUserAudioStateChanged,
            writable: false,
            enumerable: true,
        },
        roomDisconnected: {  // room-disconnected 房间失去连接事件
            value: TK.EVENT_TYPE.roomDisconnected,
            writable: false,
            enumerable: true,
        },
        getUserMediaFailure: {//getUserMedia_failure：getUserMeida失败的事件通知
            value: TK.EVENT_TYPE.getUserMediaFailure,
            writable: false,
            enumerable: true,
        },
        roomErrorNotice: { //room-error-notice 错误消息通知
            value: TK.EVENT_TYPE.roomErrorNotice,
            writable: false,
            enumerable: true,
        },
        roomUserPropertyChanged: {
            value: TK.EVENT_TYPE.roomUserPropertyChanged,
            writable: false,
            enumerable: true,
        },
        roomParticipantJoin: {
            value: TK.EVENT_TYPE.roomParticipantJoin,
            writable: false,
            enumerable: true,
        },
        roomUserScreenStateChanged: {
            value: TK.EVENT_TYPE.roomUserScreenStateChanged,
            writable: false,
            enumerable: true,
        },
        roomRtcStatsReportEvent: {
            value: TK.EVENT_TYPE.roomRtcStatsReportEvent,
            writable: false,
            enumerable: true,
        }
    });

    window.onload = function () {
        document.documentElement.style.fontSize = (document.documentElement.clientWidth || document.body.clientWidth) / 1920 * 100 + "px";
        registerEventToRoom();
    };

    window.onresize = function () {
        document.documentElement.style.fontSize = (document.documentElement.clientWidth || document.body.clientWidth) / 1920 * 100 + "px";
    };

    function getParams(key) {        //获取参数
        // var urlAdd = decodeURI(window.location.href);
        var urlAdd = decodeURIComponent(window.location.href);
        var urlIndex = urlAdd.indexOf("?");
        var urlSearch = urlAdd.substring(urlIndex + 1);
        var reg = new RegExp("(^|&)" + key + "=([^&]*)(&|$)", "i");   //reg表示匹配出:$+url传参数名字=值+$,并且$可以不存在，这样会返回一个数组
        var arr = urlSearch.match(reg);
        if (arr != null) {
            return arr[2];
        } else {
            return "";
        }
    };

    // 加入房间
    function joinRoom(host, serial, password, nick) {
        var host = host;
        var appkey = document.getElementById('ikey').value;
        window.tk_multistream = document.getElementById('selectMode').checked;
        var serial = serial;
        var password = password;
        var nick = nick;
        if (host === '') {
            alert('请输入web服务器地址...');
            return;
        }
        if (appkey === '') {
            alert('请输入企业Key（CompanyKey）...');
            return;
        }
        if (nick === '') {
            alert('请输入您的昵称...');
            return;
        }
        if (serial === '') {
            alert('请输入房间号...');
            return;
        }
        _room.init(appkey, function () {
            var myOpt = {
                class: 'one',
                grade: 'two',
            };
            _room.joinroom(host, 443, nick, '', {serial: serial, password: password}, myOpt);
            try {
                document.getElementById('loginbtn').classList.remove('disabled')
            } catch (e) {
                L.Logger.error('error info : ' + e)
            }
        }, function (errorinfo) {
            TK.Logger.error(loginType, 'init fail,fail info:' + errorinfo);
            try {
                document.getElementById('loginbtn').classList.remove('disabled')
            } catch (e) {
                L.Logger.error('error info : ' + e)
            }
            alert('初始化房间失败...');
            _room.uninit();
        }, true, {tk_multistream: window.tk_multistream, tk_host: host, tk_port: 443});
    };

    // 加入房间触发事件
    function loginTrigger(e) {
        var host = document.getElementById('ihost');
        var serial = document.getElementById('iserial');
        var password = document.getElementById('ipassword');
        var nick = document.getElementById('inick');
        var ikey = document.getElementById('ikey');
        if (serial.value == '' && nick.value == '') {
            if (
                localStorage.getItem('ikey') &&
                localStorage.getItem('iserial') &&
                localStorage.getItem('inick') &&
                localStorage.getItem('ihost')
            ) {
                try {
                    e.target.classList.add('disabled')
                } catch (e) {
                    L.Logger.error('error info : ' + e)
                }
                document.getElementById('ikey').value = localStorage.getItem('ikey');
                joinRoom(localStorage.getItem('ihost'), localStorage.getItem('iserial'), localStorage.getItem('ipassword'), localStorage.getItem('inick'));
            } else {
                alert('请手动输入完整信息！')
            }
        } else {
            try {
                e.target.classList.add('disabled')
            } catch (e) {
                L.Logger.error('error info : ' + e)
            }
            localStorage.setItem('ikey', ikey.value);
            localStorage.setItem('iserial', serial.value);
            localStorage.setItem('ipassword', password.value);
            localStorage.setItem('inick', nick.value);
            localStorage.setItem('ihost', host.value);
            joinRoom(host.value, serial.value, password.value, nick.value);
            serial.value = password.value = nick.value = '';
        }
    };

    function registerEventToRoom() {
        for (var eventKey in RoomEvent) {
            _room.addEventListener(RoomEvent[eventKey], function (recvEventData) {
                var isLog = true;
                if (recvEventData.type === 'room-usernetworkstate-changed') {
                    isLog = false;
                }
                if (isLog) {
                    L.Logger.debug(RoomEvent[eventKey] + " event:", recvEventData);
                }
                TKevent.dispatchEvent(recvEventData, false);
            });
        }
    };

    function isHas(liList, userId, attrName, Flag, trues) {
        var number = 0;
        for (var i = 0; i < liList.length; i++) {
            if (liList[i].getAttribute('extensionId') === userId) {
                number += 1;
                if (trues) {
                    return liList[i].getAttribute(attrName)
                }
                liList[i].setAttribute(attrName, Flag);
            }
        }
        return number
    };

    function removeDom(liList, mainDom, id) {
        if (id === 'All') {
            if (liList && liList.length > 0 && mainDom) {
                for (var i = liList.length - 1; i > -1; i--) {
                    mainDom.removeChild(liList[i]);
                }
            }
        }
        if (liList && liList.length > 0 && mainDom) {
            for (var i = 0; i < liList.length; i++) {
                if (liList[i].getAttribute('extensionid') === id) {
                    mainDom.removeChild(liList[i]);
                }
            }
        }
    };

    function enhanceFindLiDom(exteriorList, onlyId, tagAll) {
        if (!onlyId && !tagAll) {
            return;
        }
        var ul = document.getElementById('videoContainer');
        if (ul && ul.getElementsByTagName) {
            var list = ul.getElementsByTagName('li');
        }
        if (tagAll) {
            var lt = [];
            if (list && list.length > 0) {
                for (var j = 0; j < list.length; j++) {
                    if (list[j].getAttribute) {
                        if (list[j].getAttribute('isme') === 'true') {
                            lt.push(list[j]);
                        }
                    }
                }
            }
            return lt;
        } else {
            if (list && list.length > 0) {
                for (var i = 0; i < list.length; i++) {
                    exteriorList.forEach(function (t) {
                        if (list[i].getAttribute('extensionId') === exteriorList[t] + onlyId) {
                            return list[i];
                        }
                    })
                }
            }
        }
    };

    function openAllLocalVideo() {
        TK.DeviceMgr.getDevices(function (res) {
            videolist = res.devices.videoinput;
            videolist.forEach(function (item, index) {
                _room.playVideo(_room.getMySelf().id || '', prefixStr + item.deviceId + _room.getMySelf().id, {
                    mirror: _videoMirror,
                    loader: _videoLoader,
                    mode: _videoMode
                }, function (err) {
                    TK.Logger.error(loginType, "play video error: ", err);
                }, item.deviceId);
            })
        });
    };

    function initMy(deviceId, mdId) {
        mdId = mdId ? mdId : _room.getMySelf().tk_maincamera;
        _room.publishVideo(deviceId);
        /*创建视频区域*/
        var roomInfo = _room.getRoomProperties();
        createVideoBlock(deviceId + _room.getMySelf().id, _room.getMySelf().nickname, true, 2, mdId == deviceId);
        var container = document.getElementById('main-header');
        var triggerEle = document.getElementById('btn-pps');
        createButtons(container, {
            width: roomInfo.videowidth,
            height: roomInfo.videoheight,
            fps: roomInfo.videoframerate
        }, triggerEle);
        // 播放本地视频
        _room.playVideo(_room.getMySelf().id || '', prefixStr + deviceId + _room.getMySelf().id, {
            mirror: _videoMirror,
            loader: _videoLoader,
            mode: _videoMode
        }, function (err) {
            TK.Logger.error(loginType, "play video error: ", err);
        }, deviceId);
        additionalDom(_room.getMySelf().id + 'device', deviceId, false, true);
        var nowBtn = document.getElementById(deviceId);
        if (nowBtn) {
            nowBtn.onclick = function () {
                if (nowBtn.getAttribute('open') === 'true') {
                    _room.unpublishVideo(nowBtn.id);
                    changeBtnStats(_room.getMySelf().id, nowBtn.id, false);
                    nowBtn.setAttribute("open", 'false');
                } else {
                    _room.publishVideo(nowBtn.id);
                    changeBtnStats(_room.getMySelf().id, nowBtn.id, true, {
                        mirror: _videoMirror,
                        loader: _videoLoader,
                        mode: _videoMode
                    });
                    nowBtn.setAttribute("open", 'true');
                }
            }
        }
    };

    function delMy(deviceId, isMe, userid, isAudio) {
        if (userid === 'my') {
            userid = _room.getMySelf().id
        }
        if (userid) {
            if (isAudio) {
                delAdditionalDom(userid + 'device', deviceId)
            } else {
                delAdditionalDom(userid + 'device', deviceId + 'local' + userid);
                delAdditionalDom(userid + 'device', deviceId + '');
            }
        } else {
            _room.unpublishVideo(deviceId);
            delAdditionalDom(_room.getMySelf().id + 'device', deviceId)
        }
        var videoUl = document.getElementById('videoContainer');
        var liList = videoUl.getElementsByTagName('li');
        isMe ? removeDom(liList, videoUl, deviceId + _room.getMySelf().id) : null;
    };

    function addBtn(deviceId,userId,isMe,isAudio) {
        var nowBtn = null;
        if (isAudio) {
            nowBtn = document.getElementById(userId + 'audio');
        } else {
            nowBtn = document.getElementById(deviceId + 'local' + userId);
        }
        if (isMe === 'explore') {
            return nowBtn
        }
        if (isAudio) {
            if (!nowBtn) {
                additionalDom(userId + 'device', userId + 'audio', true);
                nowBtn = document.getElementById(userId + 'audio');
                if (nowBtn) {
                    nowBtn.onclick = function () {
                        if (nowBtn.getAttribute('open') === 'true') {
                            if (nowBtn && nowBtn.parentNode && nowBtn.parentNode.parentNode) {
                                _room.unpublishAudio();
                                nowBtn.setAttribute("open", 'false');
                                changeBtnStats(nowBtn.parentNode.parentNode.id, null, false, null, true);
                                if (nowBtn && nowBtn.parentNode && nowBtn.parentNode.parentNode) {
                                    _room.unregisterAudioVolumeListener(nowBtn.parentNode.parentNode.id, function (e) {
                                        L.Logger.error('unregisterAudioVolumeListener error:' + e);
                                    });
                                }
                            }
                        } else {
                            if (nowBtn && nowBtn.parentNode && nowBtn.parentNode.parentNode) {
                                _room.publishAudio();
                                nowBtn.setAttribute("open", 'true');
                                changeBtnStats(nowBtn.parentNode.parentNode.id, null, true, null, true);
                                var itemTime = null;
                                _room.registerAudioVolumeListener(nowBtn.parentNode.parentNode.id, 80, function (vol) {
                                    clearTimeout(itemTime);
                                    var volSpan = document.getElementById(volStr + allUser[nowBtn.parentNode.parentNode.id].maindeviceid + nowBtn.parentNode.parentNode.id);
                                    if (volSpan) {
                                        volSpan.innerText = 'vol:' + vol;
                                        itemTime = window.setTimeout(function () {
                                            volSpan.innerText = '';
                                        }, 160)
                                    }
                                }, function (err) {
                                    TK.Logger.error(loginType, 'registerAudioVolumeListener error', err);
                                });
                            }
                        }
                    }
                }
            }
        } else {
            if (!nowBtn) {
                if (isMe) {
                    additionalDom(userId + 'device', deviceId + 'local' + userId);
                    nowBtn = document.getElementById(deviceId + 'local' + userId);
                    nowBtn.onclick = function () {
                        if (nowBtn.getAttribute('open') === 'true') {
                            _room.unpublishVideo(nowBtn.id);
                            changeBtnStats(_room.getMySelf().id, nowBtn.id,false, null, null);
                            nowBtn.setAttribute("open", 'false');
                        } else {
                            _room.publishVideo(nowBtn.id);
                            changeBtnStats(_room.getMySelf().id, nowBtn.id, true, {
                                mirror: _videoMirror,
                                loader: _videoLoader,
                                mode: _videoMode
                            });
                            nowBtn.setAttribute("open", 'true');
                        }
                    }
                } else {
                    additionalDom(userId + 'device', deviceId + 'local' + userId);
                    nowBtn = document.getElementById(deviceId + 'local' + userId);
                    nowBtn.setAttribute('realdeviceid', deviceId);
                    nowBtn.setAttribute('userid', userId);
                    if (nowBtn) {
                        nowBtn.onclick = function () {
                            var realdeviceid = nowBtn.getAttribute('realdeviceid');
                            var userid = nowBtn.getAttribute('userid');
                            if (nowBtn.getAttribute('open') === 'true') {
                                if (nowBtn && nowBtn.parentNode && nowBtn.parentNode.parentNode) {
                                    changeBtnStats(nowBtn.parentNode.parentNode.id, realdeviceid, false, null, null, true);
                                    nowBtn.setAttribute("open", 'false');
                                }
                            } else {
                                if (nowBtn && nowBtn.parentNode && nowBtn.parentNode.parentNode) {
                                    changeBtnStats(nowBtn.parentNode.parentNode.id, realdeviceid, true, {
                                        mirror: _videoMirror,
                                        loader: _videoLoader,
                                        mode: _videoMode
                                    }, null, true);
                                    nowBtn.setAttribute("open", 'true');
                                }
                            }
                        }
                    }
                }
            }
        }
    }

    TK.initMy = initMy;
    TK.delMy = delMy;

    // 登录页点击进入房间
    document.getElementById('loginbtn').onclick = loginTrigger;

    // 切换房间音视频状态
    document.getElementById('switch-onlyaudio').onclick = function () {
        if (_isRoomOnlyAudio) {
            _isRoomOnlyAudio = false;
            document.getElementById('switch-onlyaudio-text').innerText = '切换为纯音频教室';
            _room.switchOnlyAudioRoom(false);
        } else {
            _isRoomOnlyAudio = true;
            document.getElementById('switch-onlyaudio-text').innerText = '切换为音视频教室';
            _room.switchOnlyAudioRoom(true);
        }
    };

    // 开启关闭服务器录制
    document.getElementById('start-transcribe').onclick = function () {
        if (_serverRecordState !== OperationState.Started) {
            var spec = {
                recordType: TK.REC_TYPE_RECFILE,
                convert: 0,
            };
            _room.startServerRecord(spec);
            _serverRecordState = OperationState.Started;
            document.getElementById('start-transcribe-text').innerText = '停止服务器端录制';
        } else {
            _room.stopServerRecord();
            _serverRecordState = OperationState.Stopped;
            document.getElementById('start-transcribe-text').innerText = '开始服务器端录制';
        }
    };

    // 离开房间
    document.getElementById('end-class').onclick = function () {
        _room.leaveroom();
        _room.uninit(function () {
            TK.Logger.info(loginType, "uninit success");
        }, function (err) {
            TK.Logger.error(loginType, "uninit uninit error: ", err);
        });
        var logiDiv = document.getElementById('login');
        var beforeSetting = document.getElementById('beforeSetting');
        logiDiv.style.display = 'block';
        beforeSetting.style.display = 'block';
        removeUserli(null, true);
        var videoUl = document.getElementById('videoContainer');
        var liList = videoUl.getElementsByTagName('li');
        removeDom(liList, videoUl, 'All');
        allUser = {};
        TK.DEMOconnected = false;
    };

    // 唤起/关闭 用户列表
    document.getElementById('user-list-btn').onclick = function () {
        var controlled = document.getElementById('user-list-outer');
        if (controlled.style.display == 'block') {
            controlled.style.display = 'none';
        } else {
            controlled.style.display = 'block'
        }
    };

    // 房间连接成功
    TKevent.addEventListener(RoomEvent.roomConnected, function (roomEvent) {
        TK.Logger.info(loginType, 'room-connected', roomEvent);
        //_room.enableDualStream(1);


        var serverAllUser = _room.getUsers();
        for (var key in serverAllUser) {
            if (!allUser.hasOwnProperty(serverAllUser[key].id)) {
                allUser[serverAllUser[key].id] = {maindeviceid: serverAllUser[key].tk_maincamera};
                createUserLi(serverAllUser[key].id, serverAllUser[key].nickname);
                if (serverAllUser[key].id !== _room.getMySelf().id) {
                    additionalDom(serverAllUser[key].id + 'device', null, null, null, serverAllUser[key].id);
                }
            }
        }
        /* 发布 音视频 */
        if(window.tk_multistream){
            TK.DeviceMgr.getDevices(function (res) {
                videolist = res.devices.videoinput;
                mdId = _room.getUser(_room.getMySelf().id).tk_maincamera;
                allUser[_room.getMySelf().id].maindeviceid = mdId;
                _room.publishAudio();
                additionalDom(_room.getMySelf().id + 'device', _room.getMySelf().id + 'audio', true);
                var nowBtn = document.getElementById(_room.getMySelf().id + 'audio');
                if (nowBtn) {
                    nowBtn.onclick = function () {
                        if (nowBtn.getAttribute('open') === 'true') {
                            if (nowBtn && nowBtn.parentNode && nowBtn.parentNode.parentNode) {
                                changeBtnStats(nowBtn.parentNode.parentNode.id, null, false, null, true);
                                nowBtn.setAttribute("open", 'false');
                                _room.unpublishAudio();
                            }
                        } else {
                            if (nowBtn && nowBtn.parentNode && nowBtn.parentNode.parentNode) {
                                changeBtnStats(nowBtn.parentNode.parentNode.id, null, true, null, true);
                                nowBtn.setAttribute("open", 'true');
                                _room.publishAudio();
                            }
                        }
                    }
                }
                var itemTimer = null;
                videolist.forEach(function (item, index) {
                    initMy(item.deviceId, mdId)
                });
                _room.registerAudioVolumeListener(_room.getMySelf().id, 80, function (vol) {
                    clearTimeout(itemTimer);
                    var volSpan = document.getElementById(volStr + mdId + _room.getMySelf().id);
                    if (volSpan) {
                        volSpan.innerText = 'vol:' + vol;
                        itemTimer = window.setTimeout(function () {
                            volSpan.innerText = '';
                        }, 160)
                    }
                }, function (err) {
                    TK.Logger.info(loginType, 'registerAudioVolumeListener err', err);
                });
            });
        }else{
            var roomInfo = _room.getRoomProperties();
            var container = document.getElementById('main-header');
            var triggerEle = document.getElementById('btn-pps');
            createButtons(container, {
                width: roomInfo.videowidth,
                height: roomInfo.videoheight,
                fps: roomInfo.videoframerate
            }, triggerEle);
            _room.publishAudio();
            _room.publishVideo();
        }
        TK.Logger.info(loginType, 'room video profile: ', _room.getVideoProfile());

        //_room.setAutoProcessDeviceChangeEvent(true);

        var logiDiv = document.getElementById('login');
        var beforeSetting = document.getElementById('beforeSetting');
        logiDiv.style.display = 'none';
        beforeSetting.style.display = 'none';

        TK.DEMOconnected = true;
    });

    // 加入房间失败
    _room.addEventListener(RoomEvent.roomError, function (roomEvent) {
        TK.Logger.error(loginType, "join room error: ", roomEvent);
        alert('加入房间失败，请核对您输入的信息！');
    });

    // 监听到用户视频状态改变
    TKevent.addEventListener(RoomEvent.roomUservideostateChanged, function (event) {
        TK.Logger.info(loginType, 'roomUservideostateChanged', event);
        var videoUl = document.getElementById('videoContainer');
        var liList = videoUl.getElementsByTagName('li');
        if (event.message.userId === _room.getMySelf().id) {
            if (event.message.published) {
                if (isHas(liList, event.message.deviceId + event.message.userId, "video", 'true', 'trues') === 'true') {
                    return
                }
                if (isHas(liList, event.message.deviceId + event.message.userId, "video", 'true') === 0 && !window.tk_multistream) {
                    createVideoBlock(event.message.deviceId + event.message.userId, _room.getUser(event.message.userId).nickname, true, 2);
                }
                _room.playVideo(event.message.userId, prefixStr + event.message.deviceId + event.message.userId, {
                    mirror: _videoMirror,
                    loader: _videoLoader,
                    mode: _videoMode
                }, function (err) {
                    TK.Logger.error(loginType, "play video error: ", err);
                }, event.message.deviceId);
                var curdom = document.getElementById(event.message.deviceId);
                if (curdom) {
                    curdom.setAttribute('open', 'true');
                    curdom.className = '';
                }
                if(!tk_multistream){
                    if(!addBtn(event.message.deviceId, event.message.userId,'explore')) {
                        addBtn(event.message.deviceId, event.message.userId, true);
                    }
                }
                isHas(liList, event.message.deviceId + event.message.userId, "video", 'true');
            } else {
                if (isHas(liList, event.message.deviceId + event.message.userId, "video", 'true', 'trues') === 'false') {
                    return
                }
                _room.unplayVideo(event.message.userId, null, event.message.deviceId);
                var curdom = document.getElementById(event.message.deviceId);
                if (curdom) {
                    curdom.setAttribute('open', 'false');
                    curdom.className = 'close ';
                }
                if(!tk_multistream){
                    delMy(event.message.deviceId, true, window.tk_multistream ? event.message.userId : null);
                }
                isHas(liList, event.message.deviceId + event.message.userId, "video", 'false');
            }
        } else {
            if (event.message.published) {
                if (isHas(liList, event.message.deviceId + event.message.userId, "video", 'true') === 0) {
                    createVideoBlock(event.message.deviceId + event.message.userId, _room.getUser(event.message.userId).nickname, false, 2);
                    _room.playVideo(event.message.userId, prefixStr + event.message.deviceId + event.message.userId, {
                        mirror: _videoMirror,
                        loader: _videoLoader,
                        mode: _videoMode
                    }, function (err) {
                        TK.Logger.error(loginType, "play video error: ", err);
                    }, event.message.deviceId);
                } else {
                    _room.playVideo(event.message.userId, prefixStr + event.message.deviceId + event.message.userId, {
                        mirror: _videoMirror,
                        loader: _videoLoader,
                        mode: _videoMode
                    }, function (err) {
                        TK.Logger.error(loginType, "play video error: ", err);
                    }, event.message.deviceId);
                }
                addBtn(event.message.deviceId, event.message.userId);
                isHas(liList, event.message.deviceId + event.message.userId, "video", 'true');
            } else {
                delMy(event.message.deviceId, false, event.message.userId);
                _room.unplayVideo(event.message.userId, null, event.message.deviceId);
                isHas(liList, event.message.deviceId + event.message.userId, "video", 'false');
                removeDom(liList, videoUl, event.message.deviceId + event.message.userId, false);
            }
        }
    });

    // 监听到用户音频状态改变
    TKevent.addEventListener(RoomEvent.roomUseraudiostateChanged, function (event) {
        TK.Logger.info(loginType, 'roomUseraudiostateChanged', event);
        if (event.message.userId === _room.getMySelf().id) {
            var audioButton = document.getElementById(event.message.userId + 'audio');
            if (event.message.published) {
                var itemTimer = null;
                _room.registerAudioVolumeListener(event.message.userId, 80, function (vol) {
                    window.clearTimeout(itemTimer);
                    var volSpan = document.getElementById(volStr + allUser[event.message.userId].maindeviceid + event.message.userId);
                    if (volSpan) {
                        volSpan.innerText = 'vol:' + vol;
                        itemTimer = window.setTimeout(function () {
                            volSpan.innerText = '';
                        }, 160)
                    }
                }, function (err) {
                    TK.Logger.error(loginType, 'registerAudioVolumeListener error', err);
                });
                if (audioButton) {
                    audioButton.setAttribute('open', 'true');
                    audioButton.className = '';
                }
                if(!tk_multistream){
                    if(!addBtn(event.message.deviceId, event.message.userId,'explore')) {
                        addBtn(event.message.deviceId, event.message.userId, true, true);
                    }
                }
            } else {
                _room.unregisterAudioVolumeListener(event.message.userId, function (e) {
                    L.Logger.error('unregisterAudioVolumeListener error:' + e);
                });
                if (audioButton) {
                    audioButton.setAttribute('open', 'false');
                    audioButton.className = 'close';
                }
            }
        } else {
            if (event.message.published) {
                _room.playAudio(event.message.userId);
                var nowBtn = document.getElementById(event.message.userId + 'audio');
                if (!nowBtn) {
                    additionalDom(event.message.userId + 'device', event.message.userId + 'audio', true);
                    nowBtn = document.getElementById(event.message.userId + 'audio');
                    if (nowBtn) {
                        nowBtn.onclick = function () {
                            if (nowBtn.getAttribute('open') === 'true') {
                                if (nowBtn && nowBtn.parentNode && nowBtn.parentNode.parentNode) {
                                    changeBtnStats(nowBtn.parentNode.parentNode.id, null, false, null, true);
                                    nowBtn.setAttribute("open", 'false');
                                    if (nowBtn && nowBtn.parentNode && nowBtn.parentNode.parentNode) {
                                        _room.unregisterAudioVolumeListener(nowBtn.parentNode.parentNode.id, function (e) {
                                            L.Logger.error('unregisterAudioVolumeListener error:' + e);
                                        });
                                    }
                                }
                            } else {
                                if (nowBtn && nowBtn.parentNode && nowBtn.parentNode.parentNode) {
                                    changeBtnStats(nowBtn.parentNode.parentNode.id, null, true, null, true);
                                    nowBtn.setAttribute("open", 'true');
                                    var itemTime = null;
                                    _room.registerAudioVolumeListener(nowBtn.parentNode.parentNode.id, 80, function (vol) {
                                        clearTimeout(itemTime);
                                        var volSpan = document.getElementById(volStr + allUser[nowBtn.parentNode.parentNode.id].maindeviceid + nowBtn.parentNode.parentNode.id);
                                        if (volSpan) {
                                            volSpan.innerText = 'vol:' + vol;
                                            itemTime = window.setTimeout(function () {
                                                volSpan.innerText = '';
                                            }, 160)
                                        }
                                    }, function (err) {
                                        TK.Logger.error(loginType, 'registerAudioVolumeListener error', err);
                                    });
                                }
                            }
                        }
                    }
                }
                var itemTime = null;
                _room.registerAudioVolumeListener(event.message.userId, 80, function (vol) {
                    clearTimeout(itemTime);
                    var volSpan = document.getElementById(volStr + allUser[event.message.userId].maindeviceid + event.message.userId);
                    if(!volSpan){
                        volSpan = document.getElementById(volStr + event.message.userId);
                    }
                    if (volSpan) {
                        volSpan.innerText = 'vol:' + vol;
                        itemTime = window.setTimeout(function () {
                            volSpan.innerText = '';
                        }, 160)
                    }
                }, function (err) {
                    TK.Logger.error(loginType, 'registerAudioVolumeListener error', err);
                });
            } else {
                _room.unplayAudio(event.message.userId);
                _room.unregisterAudioVolumeListener(event.message.userId, function (e) {
                    L.Logger.error('unregisterAudioVolumeListener error:' + e);
                });
                delMy(event.message.userId + 'audio', false, event.message.userId, true);
            }
        }
    });
    // 监听用户被踢出房间
    TKevent.addEventListener(RoomEvent.roomParticipantEvicted, function (event) {
        var videoUl = document.getElementById('videoContainer');
        var logiDiv = document.getElementById('login');
        var beforeSetting = document.getElementById('beforeSetting');
        var liList = videoUl.getElementsByTagName('li');
        for (var i = 0; i < liList.length; i++) {
            if (liList[i].getAttribute('extensionId') === event.userid) {
                liList[i].setAttribute('audio', 'false');
                liList[i].setAttribute('video', 'false');
            }
        }
        removeDom(liList, videoUl, 'All');
        _room.uninit(function () {
            TK.Logger.info(loginType, "uninit success");
        }, function (err) {
            TK.Logger.error(loginType, "uninit uninit error: ", err);
        });
        logiDiv.style.display = 'block';
        beforeSetting.style.display = 'block';
        removeUserli(null, true);
        allUser = {};
        TK.DEMOconnected = false;
        alert('您已被踢出房间，将不会再收到房间消息！');
    });

    // 房间音视频状态切换
    _room.addEventListener(RoomEvent.roomAudiovideostateSwitched, function (evt) {
        TK.Logger.info(loginType, 'room-audiovideostate-switched', evt);
        var sw = null;
        sw = window.setInterval(function () {
            if (TK.DEMOconnected) {
                var iconBoxs = document.getElementsByClassName('video-span');
                if (evt.message.onlyAudio === true) {
                    if (iconBoxs) {
                        for (var i = 0; i < iconBoxs.length; i++) {
                            if (iconBoxs[i]) {
                                iconBoxs[i].classList.add('disabled');
                                /* if (iconBoxs[i].parentNode) {
                                     iconBoxs[i].parentNode.className = 'close ';
                                     iconBoxs[i].parentNode.setAttribute("open", 'false');
                                 }*/
                            }
                        }
                    }
                    var myaudiobtn = document.getElementById(_room.getMySelf().id + 'audio');
                    if (myaudiobtn) {
                        myaudiobtn.className = ' ';
                        myaudiobtn.setAttribute("open", 'true');
                    }
                    /*var list = document.getElementsByClassName('audio-span');
                    if (list) {
                        for (var i = 0; i < list.length; i++) {
                            if (list[i] && list[i].parentNode) {
                                list[i].parentNode.setAttribute('open', 'true');
                                list[i].parentNode.className = '';
                            }
                        }
                    }*/
                    document.getElementById('switch-onlyaudio-text').innerText = '切换为音视频教室';
                    _isRoomOnlyAudio = true;
                } else {
                    if (iconBoxs) {
                        for (var i = 0; i < iconBoxs.length; i++) {
                            if (iconBoxs[i]) {
                                iconBoxs[i].classList.remove('disabled');
                                /*if (iconBoxs[i].parentNode) {
                                    iconBoxs[i].parentNode.className = '';
                                    iconBoxs[i].parentNode.setAttribute("open", 'true');
                                }*/
                            }
                        }
                    }
                    ;
                    document.getElementById('switch-onlyaudio-text').innerText = '切换为纯音频教室';
                    _isRoomOnlyAudio = false;
                }
                clearInterval(sw);
            }
        }, 300)
    });

    //房间失去连接
    _room.addEventListener(RoomEvent.roomDisconnected, function () {
        var videoUl = document.getElementById('videoContainer');
        var liList = videoUl.getElementsByTagName('li');
        removeDom(liList, videoUl, 'All');
        var cnt = document.getElementById(_room.getMySelf().id + 'device');
        if (cnt) {
            var divs = cnt.getElementsByTagName('div');
            if (divs && divs.length) {
                for (var j = divs.length - 1; j > -1; j--) {
                    cnt.removeChild(divs[j])
                }
            }
        }
        TK.DEMOconnected = false;
    });

    // 用户属性改变
    _room.addEventListener(RoomEvent.roomUserPropertyChanged, function (event) {
        TK.Logger.info(loginType, 'roomUserPropertyChanged', event);
        if (event.message.tk_maincamera) {
            if ((event.userId === _room.getMySelf().id)) {
                var mdId = event.message.tk_maincamera;
                var appointAry = enhanceFindLiDom(null, null, true);
                f(appointAry, mdId);
                _room.unregisterAudioVolumeListener(event.userId, function (e) {
                    L.Logger.error('unregisterAudioVolumeListener error:' + e);
                });
                if (allUser[event.userId]) {
                    allUser[event.userId].maindeviceid = event.message.tk_maincamera;
                } else {
                    allUser[event.userId] = {maindeviceid: event.message.tk_maincamera};
                }
                var itemTimer = null;
                _room.registerAudioVolumeListener(event.userId, 80, function (vol) {
                    clearTimeout(itemTimer);
                    var volSpan = document.getElementById(volStr + allUser[event.userId].maindeviceid + event.userId);
                    if (volSpan) {
                        volSpan.innerText = 'vol:' + vol;
                        itemTimer = window.setTimeout(function () {
                            volSpan.innerText = ''
                        }, 160)
                    }
                }, function (err) {
                    TK.Logger.error(loginType, 'registerAudioVolumeListener error', err);
                });

                function f(appoint, mdId) {
                    for (var i = 0; i < appoint.length; i++) {
                        if (appoint[i] && appoint[i].getElementsByClassName) {
                            var cur = appoint[i].getElementsByClassName('flag')[0];
                            if (cur) {
                                if (cur && cur.parentNode && cur.parentNode.getAttribute && cur.parentNode.getAttribute('extensionId').indexOf(mdId) != -1) {
                                    cur.className = 'flag mainDevice ';
                                } else {
                                    cur.className = 'flag ';
                                }
                            }
                        }
                    }
                }
            } else {
                _room.unregisterAudioVolumeListener(event.userId, function (e) {
                    L.Logger.error('unregisterAudioVolumeListener error:' + e);
                });
                if (allUser[event.userId]) {
                    allUser[event.userId].maindeviceid = event.message.tk_maincamera;
                } else {
                    allUser[event.userId] = {maindeviceid: event.message.tk_maincamera};
                }
                window.setTimeout(function () {
                    var itemTimer = null;
                    _room.registerAudioVolumeListener(event.userId, 80, function (vol) {
                        clearTimeout(itemTimer);
                        var volSpan = document.getElementById(volStr + allUser[event.userId].maindeviceid + event.userId);
                        if (volSpan) {
                            volSpan.innerText = 'vol:' + vol;
                            itemTimer = window.setTimeout(function () {
                                volSpan.innerText = ''
                            }, 160)
                        }
                    }, function (err) {
                        TK.Logger.error(loginType, 'registerAudioVolumeListener error', err);
                    });
                }, 1000)
            }
        }
    });

    // 有其他用户加入教室
    _room.addEventListener(RoomEvent.roomParticipantJoin, function (event) {
        if (!allUser.hasOwnProperty(event.userid)) {
            allUser[event.userid] = {maindeviceid: _room.getUser(event.userid).tk_maincamera};
            createUserLi(event.userid, event.user.nickname);
            additionalDom(event.userid + 'device', null, null, null, event.userid);
        }
    });

    // 有其他用户离开教室
    _room.addEventListener(RoomEvent.roomParticipantLeave, function (event) {
        if (allUser.hasOwnProperty(event.userid)) {
            delete allUser[event.userid];
            removeUserli(event.userid)
        }
    });

    _room.addEventListener(RoomEvent.roomUserScreenStateChanged, function (event) {
        var event = event.message;
        if (event.published) {
            sharePubId = event.userId;
            sharedBlock = document.createElement('div');
            var body = document.getElementsByTagName('body')[0];
            sharedBlock.id = 'sharedBlock';
            sharedBlock.className = 'sharedBlock';
            body.appendChild(sharedBlock);
            sharedBlock.onclick = function () {
                if (this.requestFullscreen) {
                    this.requestFullscreen();
                }
            };
            _room.playVideo(event.userId, 'sharedBlock', {mediaType: 'screen'});
        } else {
            if (event.userId && event.userId === _room.getMySelf().id) {
                _room.stopShareScreen()
            }
            sharePubId = '';
            var body = document.getElementsByTagName('body')[0];
            if (sharedBlock) {
                body.removeChild(sharedBlock);
            }
            _room.unplayVideo(event.userId, null, null, {mediaType: 'screen'})
        }
    });

    _room.addEventListener(RoomEvent.roomRtcStatsReportEvent, function (event) {
        //console.info(event.message.stats);
    });

    /*============================= share =====================================*/
    share.onclick = function () {
        if (sharePubId && sharePubId !== _room.getMySelf().id) {
            alert('It s already being Shared...');
            return
        }
        var sharedBlock = document.getElementById('sharedBlock');
        if (sharedBlock) {
            alert('Are Shared...');
            return
        }
        _room.startShareScreen(null, function (code, info) {
            if (code === window.TK_ERR.CHECK_USERDesktopMediaError) {
                alert(info)
            }
        });
    };

    shareStop.onclick = function () {
        if (sharePubId && sharePubId !== _room.getMySelf().id) {
            alert('It s already being Shared,Not triggered...');
            return
        }
        var sharedBlock = document.getElementById('sharedBlock');
        if (!sharedBlock) {
            alert('It not thing to share...');
            return
        }
        _room.stopShareScreen()
    };
    /*============================= share =====================================*/
})();